import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import weaponlib
import time
import string
import psyco
from xpints import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Zombie Class'
info.version = '1.0.17'
info.basename = '10pintsZombies'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'


psyco.full()
################################################################################
#																			  #
#							 Do not Edit Below This Point                     #
#																			  #
################################################################################
zombiedata = shelve.open(es.getAddonPath('xpints') + '/data/zombiedata.data', writeback=True)
player = xpints.player()

################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	global zombies
	zombies = zombie()
	
def unload():
	zombiedata.sync()
	
def round_start(ev):
	doshit = 1
	
def player_death(ev):
	zombies.death(ev)
	
def player_spawn(ev):
	zombies.spawn(ev)
	
def round_end(ev):
	roundEnd(ev)

def player_hurt(ev):
	zombies.playerHurt(ev)

def item_pickup(ev):
	zombies.onPickup(ev)
	
def es_map_start(ev):
	zombies.mapStart(ev)
	random.seed()
	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
def roundEnd(ev):
	doshit = 1


################################################################################
#						 													  #
#					 	        Zombie Class                                  #
#																			  #
################################################################################


class zombie:
	def __init__(self):
		self.zombieModels = ('player/pil/classic',
			'player/pil/fast_v5/pil_fast_v5',
			'player/pil/corpse/zombiecorpse',
			'player/pil/poison/poison',
			'player/pil/crispier_v2/crispy')
		self.classic = 0
		self.fast = 0
		self.corpse = 0
		self.poison = 0
		self.crispy = 0
			
		
	
	def playerHurt(self, ev):
		attacker = ev['attacker']
		if es.getplayerteam(attacker) == 3:
			self.effects(ev)
	def effects(self, ev):
		attacker = ev['attacker']
		victim = ev['userid']
		player.bleed(victim, 10, attacker,  1, 3)
		#player.damage(victim, 30, attacker)
	def spawn(self, ev):
		team = ev['es_userteam']
		userid = ev['userid']
		if team == '3':
			try:
				aplayer = playerlib.getPlayer(userid)
				player.addSpeed(userid, .1)
				aplayer.setArmor(150)
				aplayer.set('model', random.choice(self.zombieModels))
				aplayer.setNightvisionState(1)
				#es.server.queuecmd('est_give %s weapon_knife' %userid)
				player.viewOverlay(userid,'effects/tp_eyefx/tpeye3.vmt')
				#player.viewOverlay(userid,'effects/tp_eyefx/tpeye2.vmt')
				#es.cexec(userid, "r_screenoverlay effects/tp_eyefx/tp_eyefx.vmt")
				gamethread.delayed(1,self.hideWeapon,aplayer)
				self.specialZombie(userid)
			except:
				es.dbgmsg(0,'Zombie Spawn Error, Probably a bot that spawned before game start')
	
	def specialZombie(self,userid):
		rand = random.randint(1,100)
		if rand >= 90:
			player.addSpeed(userid, .5)
			player.addHealth(userid, -100)
			es.tell(userid, "#green", "You have spawned as a fast zombie")
	
	def hideWeapon(self,aplayer):
		list = es.getUseridList()
		if int(aplayer.userid) in list:
			if aplayer.weapon:
				aplayer.setWeaponColor(0, 0, 0, 0)
			else:
				es.dbgmsg(0,'Cant hide weapon, weapon not found')
		else:
			es.dbgmsg(0,'Cant hide weapon, player not found')
	
	def death(self,ev):
		team = ev['es_userteam']
		if team == '3':
			gamethread.delayed(1,player.spawn,ev['userid'])
	
	def onPickup(self, ev):
		try:
			team = ev['es_userteam']
			if team == '3':
				self.zombieStrip(ev['userid'])
		except:
			pass
	
	def zombieStrip(self,userid):
		if int(userid) in es.getUseridList():
			aplayer = playerlib.getPlayer(userid)
			for index, weapon in weaponlib.getWeaponIndexList():#Thanks to Satoon
				if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == aplayer.handle and weapon != 'weapon_knife':
					es.server.cmd('es_xremove %s'%index)
			es.sexec(userid, "use weapon_knife")
		else:
			es.dbgmsg(0,'Cant Strip Player, player not found')
			
	def mapStart(self,ev):
		self.classic = es.precachemodel('models/player/pil/classic.mdl')
		self.fast = es.precachemodel('models/player/pil/fast_v5/pil_fast_v5.mdl')
		self.corpse = es.precachemodel('models/player/pil/corpse/zombiecorpse.mdl')
		self.poison = es.precachemodel('models/player/pil/poison/poison.mdl')
		self.crispy = es.precachemodel('models/player/pil/crispier_v2/crispy.mdl')
		
		zview = es.precachemodel('effects/tp_eyefx/tpeye2.vmt')
		
		modelList = ('.mdl', '.dx80.vtx', '.dx90.vtx', '.phy', '.sw.vtx', '.vvd', '.xbox.vtx')
		materialList = ('.vmt', '.vtf',)
		for ext in modelList:
			es.stringtable('downloadables', 'models/player/pil/classic' + ext)
			es.stringtable('downloadables', 'models/player/pil/fast_v5/pil_fast_v5' + ext)
			es.stringtable('downloadables', 'models/player/pil/corpse/zombiecorpse' + ext)
			es.stringtable('downloadables', 'models/player/pil/poison/poison' + ext)
			es.stringtable('downloadables', 'models/player/pil/crispier_v2/crispy' + ext)



			
##################################################################################################
#EOF
##################################################################################################